Option Explicit On 

Module modAux

    Public Structure POINTAPI
        Public x, y As Integer
    End Structure

    Public Declare Function GetCaretPos Lib "user32" (ByRef lpPoint As POINTAPI) As Integer
    Public Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Integer, ByRef lpPoint As POINTAPI) As Integer
    '---------------------------------------------------------------------------------------------------

    '================================================
    'Use the ChangeGripPosition sub supplied below whenever 
    'you want the Grip control automatically adjust its location 
    'and the resize direction. 
    '================================================

    Public Sub ChangeGripPosition(ByVal g As AlterS.Grip, _
        ByVal DropDirection As Integer)

        If (DropDirection And AlterS.DDBEnum.ddbDropDirection.ddbUp) <> 0 And _
            (DropDirection And AlterS.DDBEnum.ddbDropDirection.ddbRight) <> 0 Then
            g.ResizeDirection = AlterS.GripEnum.GripResizeDirection.grpTOP_RIGHT
        End If

        If (DropDirection And AlterS.DDBEnum.ddbDropDirection.ddbDown) <> 0 And _
            (DropDirection And AlterS.DDBEnum.ddbDropDirection.ddbRight) <> 0 Then
            g.ResizeDirection = AlterS.GripEnum.GripResizeDirection.grpBOTTOM_RIGHT
        End If

        If (DropDirection And AlterS.DDBEnum.ddbDropDirection.ddbDown) <> 0 And _
            (DropDirection And AlterS.DDBEnum.ddbDropDirection.ddbLeft) <> 0 Then
            g.ResizeDirection = AlterS.GripEnum.GripResizeDirection.grpBOTTOM_LEFT
        End If

        If (DropDirection And AlterS.DDBEnum.ddbDropDirection.ddbUp) <> 0 And _
            (DropDirection And AlterS.DDBEnum.ddbDropDirection.ddbLeft) <> 0 Then
            g.ResizeDirection = AlterS.GripEnum.GripResizeDirection.grpTOP_LEFT
        End If
    End Sub

    '    Public Function FitStringToSingleLineLabel(ByRef lbl As Label, ByVal str As String) As String
    '        On Error GoTo errH

    '        Dim newStringFormat As New StringFormat
    '        Dim g As Graphics
    '        Dim charactersFitted As Integer
    '        Dim linesFilled As Integer
    '        Dim s As New SizeF(lbl.Width - 1, lbl.Height)
    '        g = lbl.CreateGraphics
    '        Dim cfOld As Integer

    '        newStringFormat.Alignment = StringAlignment.Near
    '        newStringFormat.FormatFlags = StringFormatFlags.LineLimit

    '        g.MeasureString(str, lbl.Font, _
    '            s, newStringFormat, charactersFitted, linesFilled)

    '        If str.Length = charactersFitted Then
    '            FitStringToSingleLineLabel = str
    '            Exit Function
    '        End If


    '        newStringFormat.Trimming = StringTrimming.EllipsisCharacter

    '        g.MeasureString(str, lbl.Font, _
    '               s, newStringFormat, charactersFitted, linesFilled)


    '        str = str.Substring(0, charactersFitted) + " ..."
    '        Do
    '            str = str.Substring(0, Len(str) - 4) + "..."
    '            g.MeasureString(str, lbl.Font, _
    '                  s, newStringFormat, charactersFitted, linesFilled)

    '        Loop While Not (str.Length = charactersFitted)

    '        FitStringToSingleLineLabel = str
    '        Exit Function
    'errH:
    '        MsgBox(Err.Number & " " & Err.Description & " " & Err.Source & vbCrLf & "Function: FitStringToSingleLineLabel")
    '    End Function


End Module
