using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;

namespace DemoDDB_Csharp
{
	
	/// <summary>
	/// Summary description for frmTemplateSmartList.
	/// </summary>
	public class frmTemplateSmartList : System.Windows.Forms.Form
	{

		public AlterS.DDButton ParentDDButton;  
		public string ValueToSet;

		public int Type;

		struct ElementInfo
		{
			public string Name;
			public int Type;
			public bool IsImplemented;

			public ElementInfo(string Name, int Type, bool IsImplemented) 
			{
				this.Name = Name ;
				this.Type = Type;
				this.IsImplemented =IsImplemented;
			}
		}


		private Hashtable colMethods = new Hashtable ();
		private Hashtable colEvents = new Hashtable ();
		private Hashtable colProperties = new Hashtable ();
		internal System.Windows.Forms.ImageList ImageList1;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.ListView ListView1;
		internal System.Windows.Forms.ColumnHeader c;
		internal System.Windows.Forms.Splitter Splitter1;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.CheckBox chkImplemented;
		internal System.Windows.Forms.CheckBox chkProperties;
		internal System.Windows.Forms.CheckBox chkEvents;
		internal System.Windows.Forms.CheckBox chkMethods;
		internal System.Windows.Forms.Label Label4;
		private System.ComponentModel.IContainer components;

		public frmTemplateSmartList()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			InitParams();
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmTemplateSmartList));
			this.ImageList1 = new System.Windows.Forms.ImageList(this.components);
			this.Label5 = new System.Windows.Forms.Label();
			this.ListView1 = new System.Windows.Forms.ListView();
			this.c = new System.Windows.Forms.ColumnHeader();
			this.Splitter1 = new System.Windows.Forms.Splitter();
			this.Label3 = new System.Windows.Forms.Label();
			this.Label2 = new System.Windows.Forms.Label();
			this.Label1 = new System.Windows.Forms.Label();
			this.chkImplemented = new System.Windows.Forms.CheckBox();
			this.chkProperties = new System.Windows.Forms.CheckBox();
			this.chkEvents = new System.Windows.Forms.CheckBox();
			this.chkMethods = new System.Windows.Forms.CheckBox();
			this.Label4 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// ImageList1
			// 
			this.ImageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.ImageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ImageList1.ImageStream")));
			this.ImageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// Label5
			// 
			this.Label5.BackColor = System.Drawing.Color.Black;
			this.Label5.Location = new System.Drawing.Point(1, 27);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(252, 2);
			this.Label5.TabIndex = 24;
			// 
			// ListView1
			// 
			this.ListView1.Alignment = System.Windows.Forms.ListViewAlignment.Left;
			this.ListView1.BackColor = System.Drawing.SystemColors.Window;
			this.ListView1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.ListView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.c});
			this.ListView1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ListView1.ForeColor = System.Drawing.SystemColors.WindowText;
			this.ListView1.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.None;
			this.ListView1.HideSelection = false;
			this.ListView1.LabelWrap = false;
			this.ListView1.Location = new System.Drawing.Point(12, 32);
			this.ListView1.MultiSelect = false;
			this.ListView1.Name = "ListView1";
			this.ListView1.Size = new System.Drawing.Size(224, 122);
			this.ListView1.SmallImageList = this.ImageList1;
			this.ListView1.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.ListView1.TabIndex = 23;
			this.ListView1.View = System.Windows.Forms.View.Details;
			// 
			// c
			// 
			this.c.Width = 50;
			// 
			// Splitter1
			// 
			this.Splitter1.BackColor = System.Drawing.Color.Black;
			this.Splitter1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.Splitter1.Location = new System.Drawing.Point(0, 242);
			this.Splitter1.MinExtra = 50;
			this.Splitter1.Name = "Splitter1";
			this.Splitter1.Size = new System.Drawing.Size(252, 2);
			this.Splitter1.TabIndex = 22;
			this.Splitter1.TabStop = false;
			// 
			// Label3
			// 
			this.Label3.BackColor = System.Drawing.SystemColors.ControlDark;
			this.Label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label3.ForeColor = System.Drawing.SystemColors.Window;
			this.Label3.Location = new System.Drawing.Point(176, 4);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(23, 20);
			this.Label3.TabIndex = 20;
			this.Label3.Text = "100";
			this.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label2
			// 
			this.Label2.BackColor = System.Drawing.SystemColors.ControlDark;
			this.Label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label2.ForeColor = System.Drawing.SystemColors.Window;
			this.Label2.Location = new System.Drawing.Point(110, 4);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(23, 20);
			this.Label2.TabIndex = 19;
			this.Label2.Text = "100";
			this.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Label1
			// 
			this.Label1.BackColor = System.Drawing.SystemColors.ControlDark;
			this.Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label1.ForeColor = System.Drawing.SystemColors.Window;
			this.Label1.Location = new System.Drawing.Point(42, 4);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(26, 20);
			this.Label1.TabIndex = 18;
			this.Label1.Text = "100";
			this.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// chkImplemented
			// 
			this.chkImplemented.BackColor = System.Drawing.SystemColors.ControlDark;
			this.chkImplemented.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.chkImplemented.Font = new System.Drawing.Font("Verdana", 8.25F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.chkImplemented.ForeColor = System.Drawing.SystemColors.Window;
			this.chkImplemented.Location = new System.Drawing.Point(210, 4);
			this.chkImplemented.Name = "chkImplemented";
			this.chkImplemented.Size = new System.Drawing.Size(32, 20);
			this.chkImplemented.TabIndex = 17;
			this.chkImplemented.Text = "V";
			// 
			// chkProperties
			// 
			this.chkProperties.BackColor = System.Drawing.SystemColors.ControlDark;
			this.chkProperties.Checked = true;
			this.chkProperties.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkProperties.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.chkProperties.ForeColor = System.Drawing.SystemColors.Window;
			this.chkProperties.Image = ((System.Drawing.Image)(resources.GetObject("chkProperties.Image")));
			this.chkProperties.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.chkProperties.Location = new System.Drawing.Point(72, 4);
			this.chkProperties.Name = "chkProperties";
			this.chkProperties.Size = new System.Drawing.Size(38, 20);
			this.chkProperties.TabIndex = 15;
			// 
			// chkEvents
			// 
			this.chkEvents.BackColor = System.Drawing.SystemColors.ControlDark;
			this.chkEvents.Checked = true;
			this.chkEvents.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkEvents.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.chkEvents.ForeColor = System.Drawing.SystemColors.Window;
			this.chkEvents.Image = ((System.Drawing.Image)(resources.GetObject("chkEvents.Image")));
			this.chkEvents.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.chkEvents.Location = new System.Drawing.Point(8, 4);
			this.chkEvents.Name = "chkEvents";
			this.chkEvents.Size = new System.Drawing.Size(34, 20);
			this.chkEvents.TabIndex = 14;
			this.chkEvents.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// chkMethods
			// 
			this.chkMethods.BackColor = System.Drawing.SystemColors.ControlDark;
			this.chkMethods.Checked = true;
			this.chkMethods.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkMethods.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.chkMethods.ForeColor = System.Drawing.SystemColors.Window;
			this.chkMethods.Image = ((System.Drawing.Image)(resources.GetObject("chkMethods.Image")));
			this.chkMethods.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.chkMethods.Location = new System.Drawing.Point(140, 4);
			this.chkMethods.Name = "chkMethods";
			this.chkMethods.Size = new System.Drawing.Size(36, 20);
			this.chkMethods.TabIndex = 16;
			this.chkMethods.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// Label4
			// 
			this.Label4.BackColor = System.Drawing.SystemColors.ControlDark;
			this.Label4.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.Label4.ForeColor = System.Drawing.SystemColors.Window;
			this.Label4.Location = new System.Drawing.Point(0, 244);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(252, 50);
			this.Label4.TabIndex = 21;
			this.Label4.Text = "Use the splitter to resize the description area.";
			// 
			// frmTemplateSmartList
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ControlDark;
			this.ClientSize = new System.Drawing.Size(252, 294);
			this.Controls.Add(this.Label5);
			this.Controls.Add(this.ListView1);
			this.Controls.Add(this.Splitter1);
			this.Controls.Add(this.Label3);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.chkImplemented);
			this.Controls.Add(this.chkProperties);
			this.Controls.Add(this.chkEvents);
			this.Controls.Add(this.chkMethods);
			this.Controls.Add(this.Label4);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Name = "frmTemplateSmartList";
			this.ShowInTaskbar = false;
			this.Text = "frmTemplateSmartList";
			this.Load += new System.EventHandler(this.frmTemplateSmartList_Load);
			this.ResumeLayout(false);

		}
		#endregion


		private  void InitParams(){
			this.GetData();
			this.FillListView();
		}


		public void FillListView(){
			ListView1.Visible = false;

			ListView1.Items.Clear();

			if (this.chkEvents.Checked) {
				FillLVWfromCollection(ref this.colEvents);
			}


			if (this.chkProperties.Checked) {
				FillLVWfromCollection(ref this.colProperties);
			}

			if (this.chkMethods.Checked) {
				FillLVWfromCollection(ref this.colMethods);
			}

			ListView1.Visible = true;
		}

		public void GetData(){
			int i;
			EventDescriptorCollection events;

			Random r = new Random(34);	

			events=  TypeDescriptor.GetEvents(ListView1);
			foreach (EventDescriptor myEvent in events) 
			{
				AddElementToCollection(myEvent.DisplayName.ToString(), ref this.colEvents, 0, ref r);
			}
			Label1.Text = colEvents.Count.ToString();


	        PropertyDescriptorCollection  properties;
			properties = TypeDescriptor.GetProperties(ListView1);
			foreach (PropertyDescriptor cProperty in properties) 
			{
				AddElementToCollection(cProperty.DisplayName.ToString(), ref this.colProperties, 1, ref r);
			}
			Label2.Text = colProperties.Count.ToString();

			Type myType =(typeof(ListView));
			MethodInfo[] myArrayMethodInfo = myType.GetMethods(BindingFlags.Public|BindingFlags.Instance|BindingFlags.DeclaredOnly);
	        
			for (i=0; i<myArrayMethodInfo.Length ; i++){
				MethodInfo myMethodInfo = (MethodInfo)(myArrayMethodInfo[i]);
				AddElementToCollection(myMethodInfo.Name.ToString() , ref this.colMethods, 2,ref r);
			}

			Label3.Text = colMethods.Count.ToString();
		
		}

		private void AddElementToCollection(string Name, ref Hashtable c, int Type, ref Random r)
		{
			ElementInfo ei = new ElementInfo(Name,  Type, false) ;
			double d;

			try
			{
				if ((int)(ei.Type) != 1 )
				{
					//we generate random set of "implemented" events and methods 
					//To highlight them we use different color. 
					d=Math.Abs(r.Next());
					d=System.Convert.ToDouble((d.ToString().Substring(0,3)))/250; 

					if ((int)d < 1) 
					{
						ei.IsImplemented = true;
					}
				}
				c.Add (ei.Name ,ei);
			}
			catch{}

		}


		private void FillLVWfromCollection(ref Hashtable c){
			ElementInfo ei;
			ListViewItem lvItem;
			Color cImplemented;

			cImplemented = Color.FromKnownColor(KnownColor.BlanchedAlmond);
		
			foreach(string s in c.Keys )
			{
				ei =(ElementInfo)c[s];

				if (chkImplemented.Checked)
				{
					if (ei.IsImplemented) 
					{
						lvItem = ListView1.Items.Add(ei.Name, ei.Type);
						lvItem.BackColor = cImplemented;
						lvItem.ForeColor = Color.FromKnownColor(KnownColor.Black);
						lvItem.Tag = ei.Type;
					}
				}
				else{
					lvItem = ListView1.Items.Add(ei.Name, ei.Type);
					lvItem.Tag = ei.Type;
					if (ei.IsImplemented) {
						lvItem.BackColor = cImplemented;
						lvItem.ForeColor = Color.FromKnownColor(KnownColor.Black);
					}
				}
			}
    }

		private void frmTemplateSmartList_Load(object sender, System.EventArgs e)
		{

			this.chkEvents.CheckedChanged+=new EventHandler(chk_CheckedChanged); 
			this.chkImplemented.CheckedChanged+=new EventHandler(chk_CheckedChanged); 
			this.chkMethods.CheckedChanged+=new EventHandler(chk_CheckedChanged); 
			this.chkProperties.CheckedChanged+=new EventHandler(chk_CheckedChanged); 

			this.ListView1.MouseMove +=new MouseEventHandler(ListView1_MouseMove);
			this.ListView1.MouseDown+=new MouseEventHandler(ListView1_MouseDown);

			Splitter1.Move+=new EventHandler(Splitter1_Move);

			ListView1.Visible =false;
			ListView1.Columns[0].Width = ListView1.Width - 20;
			Splitter1_Move(null, null); //resize
			ListView1.Items[0].Selected = true;
			ListView1.Visible =true;
			ListView1.Focus();
		}

		private void Splitter1_Move(object sender, EventArgs e)
		{
			ListView1.Top = Label5.Top + Label5.Height;
			ListView1.Left = Label4.Left+2;
			ListView1.Width = Label4.Width-4;
			ListView1.Height = Splitter1.Top - (Label5.Top + Label5.Height);
		}

		private void chk_CheckedChanged(object sender, EventArgs e)
		{
			if (this.Visible){
				this.FillListView();
			}
		}

		private void ListView1_MouseMove(object sender, MouseEventArgs e)
		{
			ListViewItem sl;

			ListView1.Focus();

			sl = ListView1.GetItemAt(15, e.Y);

			if (sl != null) {
				sl.Selected = true;
				sl.Focused = true;
			}
		}

		private void ListView1_MouseDown(object sender, MouseEventArgs e)
		{
			if (ListView1.Items.Count ==0 ) {return;};

			if ((e.Button & MouseButtons.Left) !=0 )
			{
				if (ParentDDButton != null) 
				{
					ValueToSet = ListView1.SelectedItems[0].Text;
					Type = (int)ListView1.SelectedItems[0].Tag;
					ParentDDButton.RaiseEventNotify();

					ListView1.Enabled = false;
					//In the code above we disable the ListView before the form is hidden.
					//This should be done because the ListView control tries to return 
					//focus after the form is hidden. If this happens, the main form 
					//becomes inactive (this gives unwanted visual effects).
					//The control is enabled in the ddbSmartList_BeforeDropDown event handler.
					//Another control that may try to return focus in such 
					//situation is TreeView. 

					ParentDDButton.HideDroppedForm();
				}
			}

		}
	}
}
